'use strict';

const compilerSFC = require('@vue/compiler-sfc');
const qs = require('querystring');
const minify = require('html-minifier').minify;

module.exports = function (resoures) {
  const query = qs.parse(this.query.slice(1));
  const { type } = query;
  const sfc = compilerSFC.parse(resoures);

  if (type === 'script') {
    const script = sfc.descriptor.script ? sfc.descriptor.script.content : '';
    return script;
  } else if (type === 'template') {
    var template = sfc.descriptor.template.content;
    return minify(template, { removeComments: true, collapseWhitespace: true, minifyJS: true, minifyCSS: true });
  } else if (type === 'style') {
    var styles = sfc.descriptor.styles;
    if (styles.length > 0) {
      return minify(styles[0].content, { removeComments: true, collapseWhitespace: true, minifyJS: true, minifyCSS: true })
    }
    return '';
  }
};
