const path = require('path')
const loaderUtils = require('loader-utils');


module.exports = function (resoures) {
  const { resourcePath } = this;

  function loaderPath($loader, $path) {
     const result = loaderUtils.stringifyRequest($loader, `!${path.resolve(__dirname, $path)}`);
     return result.replace(/\"/g, '');
  }

  const scriptImport = (
    `var script = require('${loaderPath(this, './script.js')}!babel-loader${loaderPath(this, './selector.js')}?type=script!${resourcePath}')`
  );

  const templateImport = (
    `var template = require('${loaderPath(this, './template.js')}${loaderPath(this, './selector.js')}?type=template!${resourcePath}')`
  );

  const styleImport = (
    `var style = require('${loaderPath(this, './style.js')}!css-loader${loaderPath(this, './selector.js')}?type=style!${resourcePath}')`
  );

  const componentImport = (
    `var components = require('${loaderPath(this, './component.js')}!${resourcePath}')`
  );

  return `
    ${scriptImport}
    ${templateImport}
    ${styleImport}
    ${componentImport}

    module.exports = {
      template: template(),
      styles: '<style>' + style.default[0][1] + '</style>',
      ready: script.default,
      components: components(),
    };
  `;
};